function u = Eval_IM(k)

global wi wi0 zi vi0 vi Nui xi r y

%Computing u(k) from inverse model:

%Defining inputs xi(j,k)
xi(1,k)=r(k);  
xi(2,k)=y(k);
xi(3,k)=y(k-1);

%  xi(2,k)=r(k-1);
%  if k==2 
%  xi(3,k)=0;
%  else
%  xi(3,k)=r(k-2);
%  end


%Computing zi(i)
for i=1:Nui
    sum=wi0(i,k);
    for j=1:3
        sum=sum + xi(j,k)*wi(i,j,k);
    end
    zi(i,k)=logsig(sum);
end

%Computing U(k)
sum=vi0(k);
for i=1:Nui
    sum=sum + vi(i,k)*zi(i,k);
end

u = sum;