% Genetic Algorithm
clc; clear all; close all;

global N nbit minmax

N=2;  % Number of variables
nbit=[10 10]; % Number of bits for each variable
minmax=[0 6;0 6]; % Minimum and Maximum value for each variable

% Write objective function as a .m file 
% objfunctionPC13.m
FitnessFunction = @objfunctionPB13;




% Number of variables(bits) used in the objective function
% = 10 + 10
Nov=20;
options = gaoptimset('PopInitRange',[0;6],'Populationtype','bitstring',...
    'Generations',4000,'StallGenLimit',inf,'StallTimeLimit',inf,...
     'CrossoverFraction',0.8)    
[x,fval] = ga(FitnessFunction,Nov,options);

% Decoding the ga output, which is in binary form, to decimal
b1=0;
bn=0;
for j=1:N
    sum1=0;
    n=nbit(j);
    if (j==1)
        b1=1;
    else
        b1=b1+nbit(j-1);
    end
    bn=bn+nbit(j);
    % Calculate the decimal value:
    for k=b1:bn
        n=n-1;
        sum1=sum1+x(k)*(2^n);
    end
    var(j)=sum1;
end

% Scaling between min and max values
for j=1:N
    param(j)=minmax(j,1)...
        +(minmax(j,2)-minmax(j,1))/...
        (2^nbit(j)-1)*var(j);
end

% param is the scaled optimal value
% fval is the objective function value
param
fval


