function [J]=objfunctionPB13(x)

% x is a sequence of bits 

global N nbit minmax

% Converting binary to decimal (required by objective
% function expression
b1=0;
bn=0;
for j=1:N
    sum1=0;
    n=nbit(j);
    if (j==1)
        b1=1;
    else
        b1=b1+nbit(j-1);
    end
    bn=bn+nbit(j);
    % Calculate the decimal value:
    for k=b1:bn
        n=n-1;
        sum1=sum1+x(k)*(2^n);
    end
    var(j)=sum1;
end

% Scaling decimal value between min and max value of each variable

for j=1:N
    param(j)=minmax(j,1)...
        +(minmax(j,2)-minmax(j,1))/...
        (2^nbit(j)-1)*var(j);
end

x=param;

% Objective function

J=(x(1)^2+x(2)-11)^2+(x(1)+x(2)^2-7)^2;

